package hay.app;

import hay.app.HayExchange;
import hay.app.R;
import hay.component.HayChange;
import hay.component.HayInitalSearch;
import java.util.ArrayList;
import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.view.inputmethod.InputMethodManager;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

public class HayExchangeSearch extends ListActivity{

	private ArrayList<contact> cateList;
	private ArrayList<contact> allList;
	private ListAdapter cAdapter;
	private EditText edittext;
	String name;
	
	int type;
	Button all;
	Button checked;
	public void onCreate(Bundle savedInstanceState) {
		Log.d("hay","start");
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.exchage_search);
	
		edittext = (EditText)findViewById(R.exchage_search.EditText);
		Intent i = getIntent();
		Bundle bundle = i.getExtras();
	
		cateList = new ArrayList<contact>();
		allList = new ArrayList<contact>();

		cAdapter = new ListAdapter(cateList);
		all = (Button )findViewById(R.exchage_search.btn_all);
		checked= (Button) findViewById(R.exchage_search.btn_send);
	
		
		all.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Send a message using content of the edit text widget
				int count =0;
				Intent i2 = new Intent(HayExchangeSearch.this,HayExchange.class);
							int [] temp= new int [cateList.size()] ;
				for(int i =0; i<cateList.size();i++){
									temp[count++] = cateList.get(i).getId();
							}
							i2.putExtra("clear", 1);
							i2.putExtra("size", temp.length);
							i2.putExtra("contact_number",temp);

							setResult(RESULT_OK,i2);
							finish();
		
			}
		});
		checked.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Send a message using content of the edit text widget
				int count =0,value=0;
				Intent i2 = new Intent(HayExchangeSearch.this,HayExchange.class);
							
				for(int i =0; i<cateList.size();i++){
							if(cateList.get(i).isCheck())
								count++;
							}
				int [] temp= new int [count] ;
				for(int i =0; i<cateList.size();i++){
					if(cateList.get(i).isCheck())
						temp[value++] = cateList.get(i).getId();
				}
				i2.putExtra("clear", 0);
							i2.putExtra("size", temp.length);
							i2.putExtra("contact_number",temp);

							setResult(RESULT_OK,i2);
							Log.d("hay","button setup");
							finish();

			

			}
		});
	
		
		setListAdapter(cAdapter);
		Log.d("hay","befor wacther");
		//ġ 
		edittext.addTextChangedListener(watcher);

	
			
		
	}

	
	TextWatcher watcher = new TextWatcher() {
		public void onTextChanged(CharSequence s,int start, int before, int count) {


			cateList.clear();

			for(int i=0;i<allList.size();i++){
				String name = allList.get(i).getName();
				String input = edittext.getText().toString();

				HayInitalSearch initalsearch = new HayInitalSearch();
				if(initalsearch.isHangulInitialSound(name, input)){
					cateList.add(allList.get(i));
				}

			}

			cAdapter.notifyDataSetChanged();
		}
		public void beforeTextChanged(CharSequence s, int start,int count, int after){}
		public void afterTextChanged(Editable s) {}
	};

	protected void onListItemClick(ListView l, View v, final int position,long id) {
		super.onListItemClick(l, v, position, id);

	cateList.get(position).setCheck(!(cateList.get(position).isCheck()));

		 cAdapter.notifyDataSetChanged();
		 cAdapter.notifyDataSetInvalidated();
					
	}

	private class ListAdapter extends ArrayAdapter<contact> {

		private ArrayList<contact> items;

		public ListAdapter(ArrayList<contact> items) {
			super(HayExchangeSearch.this, 0, items);
			this.items = items;
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			View v = convertView;

			if (v == null) {
				LayoutInflater vi = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.exchage_list, null);
				v.setFocusable(false);
			}

			contact mcontact = items.get(position);
			
			if (mcontact != null) {
				TextView name = (TextView) v.findViewById(R.exchage_serach_list.TextView);
				name.setFocusable(false);
				CheckBox check =  (CheckBox) v.findViewById(R.exchage_search_list.check);
				check.setFocusable(false);
				if(mcontact.isCheck()){
					check.setChecked(true);
				}
				else
					check.setChecked(false);
				name.setText(mcontact.getName());
				

			}
			return v;
		}
	}
	protected void onPause() {
		super.onPause();
		allList.clear();
		
		InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
		imm.hideSoftInputFromWindow(edittext.getWindowToken(), 0); 
	}
	
	
	protected void onResume() {
		super.onResume();
		cateList.clear();
		//ּҷ 
		Uri uri = ContactsContract.Contacts.CONTENT_URI;
		String[] projection = new String[] {
				ContactsContract.Contacts._ID,
				ContactsContract.Contacts.DISPLAY_NAME,
				ContactsContract.Contacts.HAS_PHONE_NUMBER,
				ContactsContract.Contacts.LAST_TIME_CONTACTED
		};
		String sortOrder = ContactsContract.Contacts.DISPLAY_NAME + " COLLATE LOCALIZED ASC";

		Cursor cursor = managedQuery(uri, projection, null, null, sortOrder);

		while(cursor.moveToNext()){

			contact mcontact = new contact();

			mcontact.setId(cursor.getInt(0));
			
			mcontact.setName(cursor.getString(1));

			int hasnumber = cursor.getInt(cursor.getColumnIndex(ContactsContract.Contacts.HAS_PHONE_NUMBER));
			mcontact.setHasphone(hasnumber);

			Long t =  cursor.getLong(cursor.getColumnIndex(ContactsContract.Contacts.LAST_TIME_CONTACTED));
			mcontact.setTime(HayChange.long2String(t));
			mcontact.setCheck(false);
			if( hasnumber != 0){
				cateList.add(mcontact);
				allList.add(mcontact);
			}
		}
		cAdapter.notifyDataSetChanged();
	}
	class contact {
		int id;
		String name;
		String time;
		int hasphone;
		boolean check;
		public boolean isCheck() {
			return check;
		}
		public void setCheck(boolean check) {
			this.check = check;
		}
		public String getTime() {
			return time;
		}
		public void setTime(String time) {
			this.time = time;
		}

		public int getHasphone() {
			return hasphone;
		}

		public void setHasphone(int hasphone) {
			this.hasphone = hasphone;
		}

		public int getId() {
			return id;
		}
		public void setId(int id) {
			this.id = id;
		}

		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}
	}
}
