package hay.tab;

import hay.app.HayDetail;
import hay.app.HaySmsDetail;
import hay.app.R;
import hay.component.HayContact;
import hay.component.HayContactAdapter;
import hay.component.HayInitalSearch;
import hay.component.HayChange;
import java.util.ArrayList;
import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

public class HaySearch extends ListActivity{

	private ArrayList<contact> cateList;
	private ArrayList<contact> allList;
	private ListAdapter cAdapter;
	private EditText edittext;
	String name;

	private String[] selectNumber;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.search);

		Log.d("mytag","HaySearch" );

		edittext = (EditText)findViewById(R.search.EditText);
		cateList = new ArrayList<contact>();
		allList = new ArrayList<contact>();

		cAdapter = new ListAdapter(cateList);

		setListAdapter(cAdapter);

		//ġ 
		edittext.addTextChangedListener(watcher);
	}

	protected void onPause() {
		super.onPause();
		allList.clear();
		
		InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
		imm.hideSoftInputFromWindow(edittext.getWindowToken(),0); 
	}

	protected void onResume() {
		super.onResume();
		cateList.clear();
		//ּҷ 
		Uri uri = ContactsContract.Contacts.CONTENT_URI;
		String[] projection = new String[] {
				ContactsContract.Contacts._ID,
				ContactsContract.Contacts.DISPLAY_NAME,
				ContactsContract.Contacts.HAS_PHONE_NUMBER,
				ContactsContract.Contacts.LAST_TIME_CONTACTED
		};
		String sortOrder = ContactsContract.Contacts.DISPLAY_NAME + " COLLATE LOCALIZED ASC";

		Cursor cursor = managedQuery(uri, projection, null, null, sortOrder);

		startManagingCursor(cursor);
		
		edittext.setText("");

		while(cursor.moveToNext()){

			contact mcontact = new contact();

			mcontact.setId(cursor.getInt(0));

			mcontact.setName(cursor.getString(1));

			int hasnumber = cursor.getInt(cursor.getColumnIndex(ContactsContract.Contacts.HAS_PHONE_NUMBER));
			mcontact.setHasphone(hasnumber);

			Long t =  cursor.getLong(cursor.getColumnIndex(ContactsContract.Contacts.LAST_TIME_CONTACTED));
			mcontact.setTime(HayChange.long2String(t));

			if( hasnumber != 0){
				cateList.add(mcontact);
				allList.add(mcontact);
			}
		}
		cAdapter.notifyDataSetChanged();
	}



	TextWatcher watcher = new TextWatcher() {
		public void onTextChanged(CharSequence s,int start, int before, int count) {

			cateList.clear();

			for(int i=0;i<allList.size();i++){
				String name = allList.get(i).getName();
				String input = edittext.getText().toString();

				HayInitalSearch initalsearch = new HayInitalSearch();
				if(initalsearch.isHangulInitialSound(name, input)){
					cateList.add(allList.get(i));
				}

			}

			cAdapter.notifyDataSetChanged();
		}
		public void beforeTextChanged(CharSequence s, int start,int count, int after){}
		public void afterTextChanged(Editable s) {}
	};

	protected void onListItemClick(ListView l, View v, final int position,long id) {
		super.onListItemClick(l, v, position, id);

		ArrayList<String> phoneNumber = new ArrayList<String>();
		String[] selectString = new String[] { "Call", "SMS", " " };


		HayContactAdapter contactAdapter = new HayContactAdapter(getContentResolver());
		HayContact contact = contactAdapter.getContact(cateList.get(position).getId());

		if(contact != null){
			selectString = new String[] { "Call", "SMS", " " };
			if(contact.isHasPhone()){
				for(int i =0 ; i < contact.getPhone_type().size() ; i++){
					phoneNumber.add(contact.getPhone_number().get(i));                  
				}
				// ȣ Ƶд.
				selectNumber = new String[phoneNumber.size()];
				for(int i=0;i<phoneNumber.size();i++){
					selectNumber[i] = phoneNumber.get(i);
				}

			}
		}
		else{
			//ּҷϿ   ̴.
			selectString = new String[] { "Call", "SMS", "ּҷ߰ " };
		}

		//,ȭ,󼼺 ,

		new AlertDialog.Builder(this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectString,
				new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int what) {
				switch (what) {
				case 0:// ȭκ

					if(selectNumber.length>1){
						//ȭȣ 
						new AlertDialog.Builder(HaySearch.this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectNumber,
								new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int which) {
								Intent i = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"+ selectNumber[which]));
								startActivity(i);
							}
						}).setNegativeButton("", null).show();
					}else{
						//ٷ ȭ
						Intent i = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"+ selectNumber[0]));
						startActivity(i);
					}
					break;

				case 1: // ںκ
					if(selectNumber.length>1){
						//ȭȣ
						new AlertDialog.Builder(HaySearch.this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectNumber,
								new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int which) {
								Intent i2 = new Intent(HaySearch.this,HaySmsDetail.class);
								i2.putExtra("contact_number",selectNumber[which]);
								startActivity(i2);
							}
						}).setNegativeButton("", null).show();
					}else{
						//ٷ ȭ
						Intent i2 = new Intent(HaySearch.this,HaySmsDetail.class);
						i2.putExtra("contact_number",selectNumber[0]);
						startActivity(i2);
					}
					break;

				case 2: // 
					Intent intent = new Intent(HaySearch.this, HayDetail.class);
					intent.putExtra("contact_id", cateList.get(position).getId());
					startActivity(intent);
					break;
				}
			}
		}).setNegativeButton("", null).show();

	}

	private class ListAdapter extends ArrayAdapter<contact> {

		private ArrayList<contact> items;

		public ListAdapter(ArrayList<contact> items) {
			super(HaySearch.this, 0, items);
			this.items = items;
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			View v = convertView;

			if (v == null) {
				LayoutInflater vi = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.list_search, null);
			}

			TextView name = (TextView) v.findViewById(R.serach_list.TextView);
			name.setText(items.get(position).getName());

			return v;
		}
	}

	class contact {
		int id;
		String name;
		String time;
		int hasphone;

		public String getTime() {
			return time;
		}
		public void setTime(String time) {
			this.time = time;
		}

		public int getHasphone() {
			return hasphone;
		}

		public void setHasphone(int hasphone) {
			this.hasphone = hasphone;
		}

		public int getId() {
			return id;
		}
		public void setId(int id) {
			this.id = id;
		}

		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}
	}
}
